Graphics3D 800,600,32,2
SetBuffer BackBuffer()
AppTitle "Simulation"

;math
V1#=1	;V peshkom, m/s
V2#=1.5	;V verhom, m/s
t1=0	;Red team time, s
t2=0	;Green team time, s
S=100	;Distance, m
speed#=0.3	;Speed of simulation
rt_go=1	;Triggers for moving and finish
gt_go=1

;world
cam = CreateCamera():	PositionEntity cam,0,15,-30
light=CreateLight()
plane=CreatePlane()	:	EntityColor plane,0,0,150
start=CreateCone()
finish=CreateCone()	:	PositionEntity finish,0,0,s
cam_target=plane

;red team
cube1=CreateCube()	:	EntityColor cube1,150,0,0	:	PositionEntity cube1,-6,0,0
cube2=CreateCube()	:	EntityColor cube2,150,0,0	:	PositionEntity cube2,-3,0,0

;green team
sph1=CreateSphere()	:	EntityColor sph1,0,150,0	:	PositionEntity sph1,3,0,0
sph2=CreateSphere()	:	EntityColor sph2,0,150,0	:	PositionEntity sph2,6,0,0





While End_=0
If KeyHit(2) cam_target=cube1
If KeyHit(3) cam_target=cube2
If KeyHit(4) cam_target=sph1
If KeyHit(5) cam_target=sph2
PointEntity cam,cam_target
PositionEntity cam,EntityX(cam_target),EntityY(cam_target)+15,EntityZ(cam_target)-30
;===================================================================================
;	MOVING!
;===================================================================================
If EntityZ(cube1)<=s/2 Then MoveEntity cube1,0,0,V2*speed*rt_go
If EntityZ(cube1)>s/2 Then MoveEntity cube1,0,0,V1*speed*rt_go
If EntityZ(cube2)<=s/2 Then MoveEntity cube2,0,0,V1*speed*rt_go
If EntityZ(cube2)>s/2 Then MoveEntity cube2,0,0,V2*speed*rt_go
If EntityZ(cube1)>s And EntityZ(cube2)>s Then rt_go=0
MoveEntity sph1,0,0,V1*speed*gt_go
MoveEntity sph2,0,0,V1*speed*gt_go
If EntityZ(sph1)>s And EntityZ(sph2)>s Then gt_go=0
t1=t1+1*rt_go
t2=t2+1*gt_go
;===================================================================================
If KeyDown(1)=True Then End_=1
RenderWorld
Text 20,20,"Red team time: "+t1
Text 20,40,"Green team time: "+t2
Flip
Wend
End











